curl --request POST \
--url https://storage.{region}.basaltic.sh/v1/volumes \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "data-vol-01",
"volume_type": "ssd",
"size_gb": 100,
"performance": {
"iops": 6000,
"throughput_mib_s": 250
},
"description": "Primary data volume for app-01",
"tags": {
"environment": "production",
"team": "backend"
},
"architecture": "amd64",
"source_image": "ubuntu-24.04",
"source_snapshot": "019f24a8-4bbe-7441-93af-6bbac0413943",
"bootable": false
}
'import requests
url = "https://storage.{region}.basaltic.sh/v1/volumes"
payload = {
"name": "data-vol-01",
"volume_type": "ssd",
"size_gb": 100,
"performance": {
"iops": 6000,
"throughput_mib_s": 250
},
"description": "Primary data volume for app-01",
"tags": {
"environment": "production",
"team": "backend"
},
"architecture": "amd64",
"source_image": "ubuntu-24.04",
"source_snapshot": "019f24a8-4bbe-7441-93af-6bbac0413943",
"bootable": False
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: 'data-vol-01',
volume_type: 'ssd',
size_gb: 100,
performance: {iops: 6000, throughput_mib_s: 250},
description: 'Primary data volume for app-01',
tags: {environment: 'production', team: 'backend'},
architecture: 'amd64',
source_image: 'ubuntu-24.04',
source_snapshot: '019f24a8-4bbe-7441-93af-6bbac0413943',
bootable: false
})
};
fetch('https://storage.{region}.basaltic.sh/v1/volumes', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"volume": {
"faults": [
{
"code": "BACKUP_FAILED",
"severity": "error",
"message": "Backup upload failed.",
"details": {},
"first_at": "2023-11-07T05:31:56Z",
"last_at": "2023-11-07T05:31:56Z",
"occurrences": 1
}
],
"id": "5f8d2c1a-9b3e-4d7a-8c6f-1e2a3b4c5d6e",
"crn": "crn:storage:sa-saopaulo-1:my-account:volume/data-volume-01",
"name": "data-vol-01",
"description": "Primary data volume for app-01",
"tags": {
"environment": "production",
"team": "backend"
},
"volume_type": "ssd",
"size_gb": 100,
"performance": {
"requested": {
"iops": 3000,
"bytes_per_sec": 131072000,
"burst_iops": 0,
"burst_bytes_per_sec": 0,
"burst_seconds": 0
},
"applied": {
"iops": 3000,
"bytes_per_sec": 131072000,
"burst_iops": 0,
"burst_bytes_per_sec": 0,
"burst_seconds": 0
},
"state": "creating",
"operation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"applied_at": "2023-11-07T05:31:56Z",
"last_error": "<string>"
},
"included_io_limits": {
"iops": 3000,
"bytes_per_sec": 131072000,
"burst_iops": 0,
"burst_bytes_per_sec": 0,
"burst_seconds": 0
},
"status": "available",
"bootable": false,
"source_image_id": "a3c9e7b1-2d4f-4a6b-8e1c-9f0a1b2c3d4e",
"source_snapshot_id": "019f24a8-4bbe-7441-93af-6bbac0413943",
"created_at": "2026-01-15T09:30:00Z",
"updated_at": "2026-01-15T09:31:12Z"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000",
"params": {
"instances": 2,
"pools": 0
}
}
}{
"error": {
"code": "IDEMPOTENCY_KEY_REUSED",
"message": "This Idempotency-Key was already used with a different request payload",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "INTERNAL_ERROR",
"message": "An internal error occurred",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Crear volumen
Aceptar una solicitud de creación de volumen. La fila se mantiene en estado creating y se aprovisiona asíncronamente — poll GET hasta que el estado cambia a available (success) o error, con fallos activos.
storage:CreateVolume. Consulte permisos de almacenamiento para obtener la lista completa, lo que cubre cada una y un ejemplo de política.Autorizaciones
Un token bearer de OAuth 2.0, enviado como Authorization: Bearer <token>. Esta es la forma recomendada de autenticación.
Obtén el token intercambiando el par de claves de acceso de una cuenta de servicio en POST /v1/oauth/token con grant_type=client_credentials. Es el flujo estándar de credenciales de cliente; las bibliotecas compatibles con OAuth pueden obtener y renovar el token por ti.
curl -s -u "$KEY_ID:$SECRET" -d grant_type=client_credentials \
https://iam.basaltic.sh/v1/oauth/token
Los tokens duran una hora por defecto. El mismo par de claves de acceso también sirve como credencial AWS SigV4 para el endpoint de objetos compatible con S3, que solo acepta ese método de autenticación.
Encabezados
Clave opcional generada por el cliente que hace que una creación sea segura para la reproducción. Al volver a intentar una solicitud con la misma clave, se devuelve el resultado original literalmente en lugar de crear un recurso duplicado. Se rechaza la reutilización de una clave con un cuerpo de solicitud diferente (422); una solicitud cuya clave todavía se está procesando devuelve 409. Los registros se mantienen durante 24 horas. Usa un UUID o un token único similar.
255Cuerpo
Los nombres de los recursos no deben comenzar con el prefijo literal crn: ni ser UUID (en cualquier caso, en las formas canónica, compacta, entre corchetes o urn:uuid:).
1 - 128"data-vol-01"
Los niveles en los que se puede aprovisionar un nuevo volumen. hdd es un nivel almacenado válido, pero su grupo está reservado para almacenamiento en frío, por lo que se rechaza la creación de un volumen de bloque en él.
ssd, nvme "ssd"
1 <= x <= 16384100
Rendimiento total de lectura/escritura combinado sostenido de aprovisionamiento independiente. Las dimensiones omitidas conservan su valor actual (incluido el margen en la creación). Las SSD permiten hasta 8000 IOPS y 250 MiB/s; NVMe hasta 12000 y 500 MiB/s. El mínimo es la asignación incluida del volumen; las asignaciones mayores de derechos heredados siguen estando disponibles de forma gratuita. El rendimiento es de MiB/s enteros, excepto que se puede seleccionar una asignación heredada fraccionaria exacta para eliminar el complemento de pago. Los aumentos requieren cuota de cuenta, capacidad regional y almacenamiento saludable. Factura de extras aplicados por duración transcurrida, incluso mientras está separado o detenido.
Show child attributes
Show child attributes
"Primary data volume for app-01"
Show child attributes
Show child attributes
{ "environment": "production", "team": "backend" }
Arquitectura utilizada para la resolución de nombres source_image. Una imagen completa CRN fija su propia arquitectura.
"amd64"
Imagen UUID, nombre, nombre:versión, o CRN completo image//arquitectura//version/. Los nombres se resuelven primero en la cuenta del llamador, luego se etiquetan las imágenes del catálogo de la plataforma, utilizando la arquitectura (por defecto amd64).Mutualmente exclusivo con source_snapshot.No se aceptan etiquetas de imagen.
"ubuntu-24.04"
Clonar desde un UUID de instantánea disponible de propiedad de la cuenta o un volumen CRN anidado/snapshot/Los nombres de instantáneas sin contenido se rechazan porque esta solicitud no tiene un volumen de origen fijo.Mutualmente exclusivo con source_image; size_gb debe ser al menos el tamaño congelado de la instantánea.
"019f24a8-4bbe-7441-93af-6bbac0413943"
false
Respuesta
Creación de volumen aceptada (status=creating)
Show child attributes
Show child attributes

